Package picard.illumina.parser

## Class PerTilePerCycleFileUtil

- java.lang.Object
- - picard.illumina.parser.ParameterizedFileUtil
  - - picard.illumina.parser.PerTilePerCycleFileUtil

-     public class PerTilePerCycleFileUtil
      extends ParameterizedFileUtil

- - ### Field Summary

    - ### Fields inherited from class picard.illumina.parser.ParameterizedFileUtil

      `base, DefaultSkipEmptyFiles, extension, faker, lane, matchPattern, PER_TILE_PATTERN_STRING, skipEmptyFiles, tiles`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `PerTilePerCycleFileUtil​(String extension, File base, FileFaker faker, int lane)` |

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `List<String>` | `fakeFiles​(List<Integer> expectedTiles, int[] expectedCycles, IlluminaFileUtil.SupportedIlluminaFormat format)` | Given the expected tiles/expected cycles for this file type create a set of fake files such that the verification criteria are met.
    `boolean` | `filesAvailable()` | Determine whether or not files are available
    `static int` | `getCycleFromDir​(File tempCycleDir)` |
    `Set<Integer>` | `getDetectedCycles()` |
    `picard.illumina.parser.CycleIlluminaFileMap` | `getFiles()` |
    `picard.illumina.parser.CycleIlluminaFileMap` | `getFiles​(int[] cycles)` | Returns a cycleIlluminaFileMap with all available tiles but limited to the cycles passed in.
    `picard.illumina.parser.CycleIlluminaFileMap` | `getFiles​(List<Integer> tiles)` |
    `picard.illumina.parser.CycleIlluminaFileMap` | `getFiles​(List<Integer> tiles, int[] cycles)` | Returns a cycleIlluminaFileMap that contains only the tiles and cycles specified (and fewer if the original CycleIlluminaFileMap, created on util instantiation, doesn't contain any of these tiles/cycles).
    `protected picard.illumina.parser.CycleIlluminaFileMap` | `getPerTilePerCycleFiles()` | For the given tiles, populate a CycleIlluminaFileMap that contains all these tiles and will iterate through all the files for these tiles in expectedBase Side Effect: Assigns numCycles
    `List<Integer>` | `getTiles()` | Discover all files of this type in expectedBase that match pattern and construct a list of tiles available based on these files.
    `List<String>` | `verify​(List<Integer> expectedTiles, int[] expectedCycles)` | Given the expected tiles/expected cycles for this file type, return a list of error messages describing any missing/or malformed files

    - ### Methods inherited from class picard.illumina.parser.ParameterizedFileUtil

      `checkTileCount, escapePeriods, fileToTile, getRunFile, getTiledFiles, makeBarcodeRegex, makeLaneTileRegex, setTiles, setTilesForPerRunFile`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### PerTilePerCycleFileUtil

          public PerTilePerCycleFileUtil​(String extension,
                                         File base,
                                         FileFaker faker,
                                         int lane)

  - ### Method Detail

    - #### getPerTilePerCycleFiles

          protected picard.illumina.parser.CycleIlluminaFileMap getPerTilePerCycleFiles()

      For the given tiles, populate a CycleIlluminaFileMap that contains all these tiles and will iterate through all the files for these tiles in expectedBase Side Effect: Assigns numCycles
      Returns:
        A CycleIlluminaFileMap with the listed (or all) tiles for at least expectedCycles number of cycles(or total available cycles if expectedCycles is null)

    - #### getFiles

          public picard.illumina.parser.CycleIlluminaFileMap getFiles()

    - #### getFiles

          public picard.illumina.parser.CycleIlluminaFileMap getFiles​(List<Integer> tiles)

    - #### getFiles

          public picard.illumina.parser.CycleIlluminaFileMap getFiles​(int[] cycles)

      Returns a cycleIlluminaFileMap with all available tiles but limited to the cycles passed in. Any cycles that are missing cycle files or directories will be removed from the cycle list that is kept.
      Parameters:
        `cycles` - Cycles that should be present in the output CycleIlluminaFileMap
      Returns:
        A CycleIlluminaFileMap with all available tiles but at most the cycles passed in by the cycles parameter

    - #### getFiles

          public picard.illumina.parser.CycleIlluminaFileMap getFiles​(List<Integer> tiles,
                                                                      int[] cycles)

      Returns a cycleIlluminaFileMap that contains only the tiles and cycles specified (and fewer if the original CycleIlluminaFileMap, created on util instantiation, doesn't contain any of these tiles/cycles).
      Parameters:
        `cycles` - Cycles that should be present in the output CycleIlluminaFileMap
      Returns:
        A CycleIlluminaFileMap with at most the tiles/cycles listed in the parameters

    - #### getDetectedCycles

          public Set<Integer> getDetectedCycles()

    - #### getTiles

          public List<Integer> getTiles()

      Discover all files of this type in expectedBase that match pattern and construct a list of tiles available based on these files. The same number of tiles is expected in each cycle dir.
      Overrides:
        `getTiles` in class `ParameterizedFileUtil`
      Returns:
        A list of tile integers for all tiles available

    - #### filesAvailable

          public boolean filesAvailable()

      Description copied from class: `ParameterizedFileUtil`
      Determine whether or not files are available
      Specified by:
        `filesAvailable` in class `ParameterizedFileUtil`
      Returns:
        return true if files are found matching this types pattern, false otherwise

    - #### verify

          public List<String> verify​(List<Integer> expectedTiles,
                                     int[] expectedCycles)

      Description copied from class: `ParameterizedFileUtil`
      Given the expected tiles/expected cycles for this file type, return a list of error messages describing any missing/or malformed files
      Specified by:
        `verify` in class `ParameterizedFileUtil`
      Parameters:
        `expectedTiles` - An ordered list of tile numbers
        `expectedCycles` - An ordered list of cycle numbers that may contain gaps
      Returns:
        A list of error messages for this format

    - #### fakeFiles

          public List<String> fakeFiles​(List<Integer> expectedTiles,
                                        int[] expectedCycles,
                                        IlluminaFileUtil.SupportedIlluminaFormat format)

      Description copied from class: `ParameterizedFileUtil`
      Given the expected tiles/expected cycles for this file type create a set of fake files such that the verification criteria are met.
      Specified by:
        `fakeFiles` in class `ParameterizedFileUtil`
      Parameters:
        `expectedTiles` - An ordered list of tile numbers
        `expectedCycles` - An ordered list of cycle numbers that may contain gaps
        `format` - The format of the files that are to be faked
      Returns:
        A list of error messages for this format

    - #### getCycleFromDir

          public static int getCycleFromDir​(File tempCycleDir)